<template>
  <no-ssr>
    <div
      :class="{'_dark': !isIndex}"
      v-click-outside="onClickOutside"
      v-scroll-lock="isMobile() && isVisible"
      class="AppChatNoLogin">
      <button
        v-show="!isVisible"
        @click="isVisible = true; $ym('chat_gisauto_unauth_open')"
        class="mainbtn">
        <img
          svg-inline
          src="~/assets/svg/chat-man.svg">
        Чат с GisAuto
      </button>

      <div
        v-if="isVisible"
        class="begin-form scrollableOverlay-wrapper">
        <div class="content scrollableOverlay-container">
          <i
            class="btn-close"
            @click="isVisible = false">
            <img
              svg-inline
              src="~/assets/svg/icons/i-close-chat.svg">
          </i>
          <!-- TODO: почти такая же фома есть в AppModalBeginChat [REFACTORING] -->
          <div class="beginChat">
            <div class="beginChat-heading">
              <div class="heading _h2">Чат с технической поддержкой или&nbsp;автоконсьержем</div>
            </div>
            <div class="beginChat-form">
              <div class="form">
                <span class="beginChat-notes"><sup class="__red">*</sup> Обязательно</span>
                <div class="form-item">
                  <AppInputComposite
                    v-model="name"
                    :class="{ '-invalid': validation.hasError('name')}">
                    <template #label>Как к вам обращаться <sup class="__red">*</sup></template>
                  </AppInputComposite>
                  <div
                    v-if="validation.hasError('name')"
                    class="input-message-error _left">
                    {{ validation.firstError('name') }}
                  </div>
                </div>

                <div class="form-item">
                  <AppInputComposite
                    v-model="email"
                    :class="{ '-invalid': issetErrors.email || validation.firstError('email')}">
                    <template #label>Ваша почта</template>
                  </AppInputComposite>
                  <div
                    v-if="issetErrors.email || validation.hasError('email')"
                    class="input-message-error _left">
                    {{ issetErrors.email || validation.firstError('email') }}
                    <span
                      v-if="issetErrors.email">
                      <a
                        class="link"
                        href="#"
                        @click.prevent="isVisible = false; showAuthModal();">Авторизуйтесь
                      </a>
                      или укажите другой e-mail.
                    </span>
                  </div>
                </div>

                <div class="form-item">
                  <AppInputPhone
                    v-model="phone"
                    :options="{ validationRule: { isRequired: false } }"
                    @has-error="inputErrors.phone = $event"/>
                  <div
                    v-if="issetErrors.phone"
                    class="input-message-error _left">
                    {{ issetErrors.phone }}
                    <span v-if="issetErrors.phone">
                      <a
                        class="link"
                        @click.prevent="isVisible = false; showAuthModal();">Авторизуйтесь</a>
                      или укажите другой номер телефона.
                    </span>
                  </div>
                </div>


                <div class="form-item">
                  <div class="beginChat-notes">
                    Нажимая на кнопку «Начать чат» вы даете согласие на
                    <flink
                      target="_blank"
                      domain="main"
                      href="/about-us/agreement"
                      class="link">
                      обработку персональных данных
                    </flink>
                  </div>
                </div>

                <div
                  v-if="apiError"
                  class="form-item">
                  <div class="input-message-error">
                    Временная ошибка, пожалуйста, повторите запрос позднее
                  </div>
                </div>

                <div class="form-item">
                  <AppButton
                    @click.native="send(); $ym('chat_gisauto_begin_chat')"
                    :disabled="submitDisabled">
                    <span
                      slot="button-item"
                      class="button-item">
                      Начать чат
                    </span>
                  </AppButton>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </no-ssr>
</template>

<script>
import BeginChatMixin from '~/assets/js/mixins/redesign/begin-chat';

import AppButton from '~/components/redesign/app-buttons/app-button';
import AppInputPhone from '~/components/redesign/app-input/app-input-phone';
import AppInputComposite from '~/components/redesign/app-input/app-input-composite';
import isMobileMixin from '~/assets/js/mixins/is-mobile';

export default {
  name: 'AppChatNoLogin',
  components: {
    AppInputComposite,
    AppButton,
    AppInputPhone,
  },
  mixins: [BeginChatMixin, isMobileMixin],
  props: {
    isIndex: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      isVisibleForm: false,
      chatTooltip: {
        classes: 'tooltip tooltipDark tooltipChatNoLogin',
        trigger: 'hover',
        open: true,
        offset: '4',
        html: true,
        placement: 'left-end',
        content: `<div class="paragraph">
                    Задайте нам вопрос по подбору запчасти или сообщите о проблеме в работе сайта
                  </div>`,
      },
    };
  },
  computed: {
    isVisible: {
      get() {
        return this.isVisibleForm;
      },
      set(newVal) {
        if (newVal) {
          this.show();
        } else {
          this.hide();
        }
      },
    },
  },
  methods: {
    show() {
      this.isVisibleForm = true;
    },
    hide() {
      this.isVisibleForm = false;
    },
    onClickOutside() {
      if (this.isVisible) {
        this.hide();
      }
    },
  },
};
</script>

<style lang="postcss">
  .AppChatNoLogin {
    .mainbtn {
      cursor: pointer;
      position: fixed;
      bottom: 4.1rem;
      right: calc(var(--scroll-bar-gap) - 3.55rem);
      transform: rotate(-90deg);
      z-index: calc(var(--z-index-under-modal) - 1);
      display: flex;
      justify-content: center;
      align-items: center;
      min-width: 4.875rem;
      width: auto;
      height: 2.25rem;
      background-color: #fff;
      color: #1E7AA1;
      font-family: Roboto, sans-serif;
      font-size: 0.875rem;
      line-height: 1.2;
      font-weight: 500;
      text-transform: none;
      font-style: normal;
      box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.13);
      outline: none;
      flex-flow: row nowrap;
      padding: 0.5rem 1.25rem;
      border-top-left-radius: 4px;
      border-top-right-radius: 4px;
      border: 1px solid #e4ebf6;
      .svg {
        display: block;
        margin-right: 0.5rem;
        width: 0.75rem;
        height: 0.75rem;
        fill: #1E7AA1;
        stroke: #1E7AA1;
        transition: fill 0.1s ease, stroke 0.1s ease;
      }
      &:hover {
        .svg {
          fill: #8798a4;
          stroke: #8798a4;
        }
      }
    }

    &._dark {
      .mainbtn {
        background-color: #1E7AA1;
        border-color: #1E7AA1;
        color: #fff;
        .svg {
          fill: #fff;
          stroke: #fff;
        }
      }
    }

    .begin-form {
      position: fixed;
      bottom: 0.75rem;
      right: 1rem;
      z-index: var(--z-index-modal);

      > .content {
        position: relative;
        display: block;
        border-radius: .25rem;
        background-color: var(--bg-main);
        box-shadow: 0 2px 8px rgba(0,0,0,.33);
      }

      .input-message-error {
        text-align: center;
        display: block;
        &._left {
          text-align: left;
        }
      }

      @media only screen and (max-width: 980px) {
        display: flex;
        bottom: 0;
        right: 0;
        height: 100vh;
        width: 100vw;

        > .content {
          margin-top: auto;
          padding: 2rem 1rem 2rem;
          display: flex;
          width: 100vw;
          max-width: 30rem;
        }
      }

      @media only screen and (min-width: 981px) {
        > .content {
          width: 23rem;
          min-height: auto;
        }
      }

      .btn-close {
        position: absolute;
        z-index: 1;
        top: 0.5rem;
        right: 0.5rem;
        display: block;
        width: auto;
        height: auto;
        padding: 0.5625rem;
        cursor: pointer;

        svg {
          width: 0.625rem;
          height: auto;
          stroke: #8798a4;
          transition: stroke 0.2s ease;
        }

        &:hover {
          svg {
            stroke: #4272a4;
          }
        }

        @media only screen and (max-width: 980px) {
          padding: 0.875rem;
          svg {
            width: 0.875rem;
          }
        }
      }
    }
  }

  .beginChat {
    &-heading {
      display: block;
      padding: 2rem 1.25rem 1.25rem;
      text-align: center;

      .heading {
        font-size: 1rem;
      }
    }

    &-notes {
      display: block;
      font-size: 0.75rem;
    }

    &-form {
      display: block;
      padding: 0 1.25rem 1.75rem 1.25rem;

      .form {
        display: block;
        margin: 0 auto;
        width: 100%;
        max-width: 21.25rem;

        & > .beginChat-notes {
          display: block;
          margin-bottom: .5rem;
        }

        .invalid {
          box-shadow: inset 0 0 0 1px var(--form-error-border-color);
        }

        &-item {
          display: flex;
          flex-direction: column;
          justify-content: space-between;
          font-size: 0.75rem;
          padding-bottom: 1.5rem;


          .inputComposite {
            width: 100%;
          }

          .button {
            width: 100%;
            height: var(--btn-height-large);
          }

          .link {
            white-space: nowrap;
          }
        }
      }
    }

    @media screen and (max-width: 1200px) and (min-width: 981px) {
      &-heading {
        padding-top: 2.5rem;
      }

      &-form {
        .form-item {
          font-size: 0.875rem;
          .button {
            margin-top: 0.5rem;
          }
        }
      }
    }

    @media screen and (max-width: 980px) {
      display: flex;
      flex-direction: column;
      justify-content: center;
      flex-grow: 1;
      height: 100%;

      &-heading {
        padding-top: 2.5rem;
        .heading {
          font-size: 1.125rem;
          font-weight: var(--font-weight-medium);
        }
      }

      &-form {
        .form-item {
          font-size: 0.875rem;
          .button {
            margin-top: 0.5rem;
            font-size: 1rem;
          }
        }
      }
    }
  }
</style>
